﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ClickSpawner : MonoBehaviour
{
    #region Inspector Fields

    public GameObject SpawnObject;
    public float SpawnRate = 0.2f;
    public Camera WorldCamera;

    #endregion

    #region Private Fields

    private float _nextSpawnTime;
    private bool _mouseDownLastFrame;

    #endregion

    #region Unity Methods

    // Use this for initialization
    void Start()
    {

    }

    // Update is called once per frame
    void Update()
    {
        if (Input.GetMouseButton(0))
        {
            if (!_mouseDownLastFrame)
            {
                _nextSpawnTime = Time.time;
            }

            Vector3 spawnPoint = WorldCamera.ScreenToWorldPoint(Input.mousePosition);
            spawnPoint.z = 0;

            while (_nextSpawnTime <= Time.time)
            {
                Instantiate(SpawnObject, spawnPoint, Quaternion.identity);
                _nextSpawnTime += SpawnRate;
            }

            _mouseDownLastFrame = true;
        }
        else
        {
            _mouseDownLastFrame = false;
        }
    }

    #endregion
}
