﻿using System.Collections;
using System.Collections.Generic;
using System.Runtime.Remoting.Messaging;
using UnityEngine;
using UnityEngine.UI;

public class InventoryItemButton : MonoBehaviour
{
    public Button ItemButton;
    public Image ItemImage;
    public Text ItemCountText;
    public int LastItemCountValue = -1;

    // Use this for initialization
    void Start()
    {
        
    }
//
//    // Update is called once per frame
//    void Update()
//    {
//
//    }

    public void SetButtonImage(Sprite sprite)
    {
        ItemImage.sprite = sprite;
    }

    public void SetItemCount(int count)
    {
        if (count == LastItemCountValue)
        {
            return;
        }

        if (count < 0)
        {
            Debug.Log(name + ".ItemCount < 0, hidden");

            gameObject.SetActive(false);
            ItemButton.interactable = false;
            return;
        }

        if (count == 0)
        {
            Debug.Log(name + ".ItemCount == 0, disabled");

            gameObject.SetActive(true);
            ItemButton.interactable = false;
        }
        else
        {
            Debug.Log(name + ".ItemCount > 0, enabled");

            gameObject.SetActive(true);
            ItemButton.interactable = true;
        }

        ItemCountText.text = count.ToString("D2");
    }
}
