﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

[RequireComponent(typeof(Text))]
public class SoldierCounter : MonoBehaviour
{
    private static int _currentSoldierCount = 0;
    private static string _currentSoldierCountString = _currentSoldierCount.ToString("D4");
    private static readonly List<Text> TextAreas = new List<Text>();
    private static bool _valueChanged;

    // Use this for initialization
    void Start()
    {
        var textArea = GetComponent<Text>();
        textArea.text = _currentSoldierCountString;
        TextAreas.Add(textArea);
        
    }

    void OnDestroy()
    {
        TextAreas.Remove(GetComponent<Text>());
    }

    // Update is called once per frame
    void LateUpdate()
    {
        if (_valueChanged)
        {
            UpdateValueText();
            _valueChanged = false;
        }
    }

    public static void SetSolderCount(int count)
    {
        if (_currentSoldierCount != count)
        {
            _currentSoldierCount = count;
            _valueChanged = true;
        }
    }

    private void UpdateValueText()
    {
        _currentSoldierCountString = _currentSoldierCount.ToString("D4");

        int textAreaCount = TextAreas.Count;

        for (int i = 0; i < textAreaCount; i++)
        {
            TextAreas[i].text = _currentSoldierCountString;
        }
    }
}
