﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

[RequireComponent(typeof(HealthComponent))]
public class BaseCollisionDamageHandler : MonoBehaviour
{
    #region Fields

    protected HealthComponent Health;

    #endregion

    #region Unity Methods

    public virtual void Awake()
    {
        Health = GetComponent<HealthComponent>();
    }

    public void OnCollisionEnter2D(Collision2D coll)
    {
       HandleCollision(coll);
    }

    public virtual void HandleCollision(Collision2D coll)
    {
        var damageProvider = coll.gameObject.GetComponent<BaseCollisionDamageProvider>();

        if (damageProvider != null)
        {
            Health.AddHealth(damageProvider.GetCollisionDamage(coll.relativeVelocity.SqrMagnitude(), gameObject).Damage);
        }
    }

    #endregion
}
