﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SoldierCollisionDamageHandler : BaseCollisionDamageHandler
{
    #region Fields

    #endregion

    #region Unity Methods

    public override void Awake()
    {
        base.Awake();
    }

    public override void HandleCollision(Collision2D coll)
    {
        var damageProvider = coll.gameObject.GetComponent<BaseCollisionDamageProvider>();

        if (damageProvider != null)
        {
            var damageInfo = damageProvider.GetCollisionDamage(coll.relativeVelocity.SqrMagnitude(), gameObject);

            if (damageInfo.Kill)
            {
                Health.AddHealth(-Health.CurrentHealth);
            }
            else
            {
                Health.AddHealth(damageInfo.Damage);
            }
        }
    }

    #endregion
}
