﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SpawnPointDropPod : SpawnPointBase
{
    #region Structs

    #endregion

    #region Fields

    public Transform[] SpawnPositions;
    public Rigidbody2D[] Doors;
    public float DoorVelocity = 30f;
    public BaseSoldier FlagBearer;
    public float TimeFromDoorToSpawn = 0.1f;
    public float SpawnRate = 0.01f;

    public float LaunchVelocity = 20f;

    #endregion

    #region SpawnPointBase Methods

    public override void StartSpawn()
    {
        StartCoroutine(SpawnCoroutine());
    }

    #endregion

    #region Private Methods

    private IEnumerator SpawnCoroutine()
    {
        Debug.Log(name + " Spawn Coroutine Active!");

        //TODO: Do initial pod launch;

        yield return null;

        // Todo Do flag bearer launch;

        yield return null;

        // Explode Doors.

        var doorCount = Doors.Length;

        for (int i = 0; i < doorCount; i++)
        {
            Doors[i].simulated = true;
            Doors[i].velocity = (Doors[i].transform.position - transform.position).normalized * DoorVelocity;
            Doors[i].angularVelocity = UnityEngine.Random.Range(-540f, 540f);
        }

        var spawnStartTime = Time.time + TimeFromDoorToSpawn;

        while (Time.time < spawnStartTime)
        {
            yield return null;
        }

        // Start spawn loop

        int spawnPointIndex = 0;
        int spawnPointCount = SpawnPositions.Length;
        float nextSpawnTime = Time.time;

        while (RemainingSoldiers > 0)
        {
            while (nextSpawnTime <= Time.time)
            {
                var soldier = SpawnSoldier();
                soldier.transform.position = SpawnPositions[spawnPointIndex].position;
                soldier.Activate(SpawnPositions[spawnPointIndex].position, SpawnPositions[spawnPointIndex].rotation, LaunchVelocity);

                nextSpawnTime += SpawnRate;
                spawnPointIndex = (spawnPointIndex + 1)%spawnPointCount;

                if (RemainingSoldiers <= 0)
                {
                    break;
                }
            }

            yield return null;
        }
    }

    #endregion
}
